The Kanban component for Angular which can be used to implement the kanban method for a project.
npm install -g @angular/cli ng new jqwidgets-project cd jqwidgets-project
ng add jqwidgets-ng
jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package
npm install jqwidgets-ng
@import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';
"styles": [ "node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css" ]
<jqxSplitter [theme]="'fluent'" [width]="getWidth()" [height]='600' [panels]='mainSplitterPanels'>
<div>
<jqxKanban [theme]="'fluent'" id="kanban1" #myKanbanOne
[width]='"100%"' [height]='"100%"' [source]='dataAdapter'
[columns]='kanbanOneColumns' [connectWith]='"#kanban2, #kanban3"'
[resources]='resourcesAdapterFunc()' [columnRenderer]='kanbanOneColumnRenderer'>
</jqxKanban>
</div>
<div>
<jqxSplitter [theme]="'fluent'" [width]='"100%"' [height]='"100%"'
[orientation]='"horizontal"' [panels]='rightSplitterPanels'>
<div>
<jqxKanban [theme]="'fluent'" id="kanban2" #myKanbanTwo
[width]='"100%"' [height]='"100%"' [source]='dataAdapter2'
[columns]='kanbanTwoColumns' [connectWith]='"#kanban1, #kanban3"'
[resources]='resourcesAdapterFunc()' [columnRenderer]='kanbanTwoColumnRenderer'>
</jqxKanban>
</div>
<div>
<jqxKanban [theme]="'fluent'" id="kanban3" #myKanbanThree
[width]='"100%"' [height]='"100%"' [source]='dataAdapter3'
[columns]='kanbanThreeColumns' [connectWith]='"#kanban2, #kanban1"'
[resources]='resourcesAdapterFunc()' [columnRenderer]='kanbanThreeColumnRenderer'>
</jqxKanban>
</div>
</jqxSplitter>
</div>
</jqxSplitter>
import { Component, ViewChild } from '@angular/core';
import { jqxKanbanModule, jqxKanbanComponent } from 'jqwidgets-ng/jqxkanban';
import { jqxSplitterModule } from 'jqwidgets-ng/jqxsplitter';
@Component({
selector: 'app-root',
imports: [jqxKanbanModule, jqxSplitterModule],
standalone: true,
templateUrl: './app.component.html'
})
export class AppComponent {
@ViewChild('myKanbanOne', { static: false }) myKanbanOne: jqxKanbanComponent;
@ViewChild('myKanbanTwo', { static: false }) myKanbanTwo: jqxKanbanComponent;
@ViewChild('myKanbanThree', { static: false }) myKanbanThree: jqxKanbanComponent;
fields: any =
[
{ name: 'status', map: 'state', type: 'string' },
{ name: 'text', map: 'label', type: 'string' },
{ name: 'tags', type: 'string' },
{ name: 'color', map: 'hex', type: 'string' },
{ name: 'resourceId', type: 'number' }
];
getWidth() : any {
if (document.body.offsetWidth < 850) {
return '90%';
}
return 850;
}
source: any =
{
localData:
[
{ state: 'new', label: 'Combine Orders', tags: 'orders, combine', hex: '#5dc3f0', resourceId: 3 },
{ state: 'new', label: 'Change Billing Address', tags: 'billing', hex: '#f19b60', resourceId: 1 },
{ state: 'new', label: 'One item added to the cart', tags: 'cart', hex: '#5dc3f0', resourceId: 3 },
{ state: 'new', label: 'Edit Item Price', tags: 'price, edit', hex: '#5dc3f0', resourceId: 4 },
{ state: 'new', label: 'Login 404 issue', tags: 'issue, login', hex: '#6bbd49' }
],
dataType: 'array',
dataFields: this.fields
};
dataAdapter: any = new jqx.dataAdapter(this.source);
source2: any =
{
localData:
[
{ state: 'ready', label: 'Logout issue', tags: 'logout, issue', hex: '#5dc3f0', resourceId: 7 },
{ state: 'ready', label: 'Remember password issue', tags: 'password, issue', hex: '#6bbd49', resourceId: 8 },
{ state: 'ready', label: 'Cart calculation issue', tags: 'cart, calculation', hex: '#f19b60', resourceId: 9 },
{ state: 'ready', label: 'Remove topic issue', tags: 'topic, issue', hex: '#6bbd49' }
],
dataType: 'array',
dataFields: this.fields
};
dataAdapter2: any = new jqx.dataAdapter(this.source2);
source3: any =
{
localData:
[
{ state: 'done', label: 'Delete orders', tags: 'orders, combine', hex: '#f19b60', resourceId: 4 },
{ state: 'work', label: 'Add New Address', tags: 'address', hex: '#6bbd49', resourceId: 5 },
{ state: 'new', label: 'Rename items', tags: 'rename', hex: '#5dc3f0', resourceId: 6 },
{ state: 'work', label: 'Update cart', tags: 'cart, update', hex: '#6bbd49' }
],
dataType: 'array',
dataFields: this.fields
};
dataAdapter3: any = new jqx.dataAdapter(this.source3);
resourcesAdapterFunc = (): any => {
let resourcesSource =
{
localData:
[
{ id: 0, name: 'No name', image: './../../../jqwidgets/styles/images/common.png', common: true },
{ id: 1, name: 'Andrew Fuller', image: './../../../images/andrew.png' },
{ id: 2, name: 'Janet Leverling', image: './../../../images/janet.png' },
{ id: 3, name: 'Steven Buchanan', image: './../../../images/steven.png' },
{ id: 4, name: 'Nancy Davolio', image: './../../../images/nancy.png' },
{ id: 5, name: 'Michael Buchanan', image: './../../../images/Michael.png' },
{ id: 6, name: 'Margaret Buchanan', image: './../../../images/margaret.png' },
{ id: 7, name: 'Robert Buchanan', image: './../../../images/robert.png' },
{ id: 8, name: 'Laura Buchanan', image: './../../../images/Laura.png' },
{ id: 9, name: 'Laura Buchanan', image: './../../../images/Anne.png' }
],
dataType: 'array',
dataFields:
[
{ name: 'id', type: 'number' },
{ name: 'name', type: 'string' },
{ name: 'image', type: 'string' },
{ name: 'common', type: 'boolean' }
]
};
let resourcesDataAdapter = new jqx.dataAdapter(resourcesSource);
return resourcesDataAdapter;
}
kanbanOneColumns: any[] =
[
{ text: 'Backlog', dataField: 'new', maxItems: 10 }
];
kanbanOneColumnRenderer: any = (element: any, collapsedElement: any, column: any): void => {
if (this.myKanbanOne && element[0]) {
let headerStatus = element[0].getElementsByClassName('jqx-kanban-column-header-status')[0];
let columnItems = this.myKanbanOne.getColumnItems(column.dataField).length;
headerStatus.innerHTML = ' (' + columnItems + '/' + column.maxItems + ')';
}
}
kanbanTwoColumns: any[] =
[
{ text: 'Ready', dataField: 'ready', maxItems: 10 }
];
kanbanTwoColumnRenderer: any = (element: any, collapsedElement: any, column: any): void => {
if (this.myKanbanTwo && element[0]) {
let headerStatus = element[0].getElementsByClassName('jqx-kanban-column-header-status')[0];
let columnItems = this.myKanbanTwo.getColumnItems(column.dataField).length;
headerStatus.innerHTML = ' (' + columnItems + '/' + column.maxItems + ')';
}
}
kanbanThreeColumns: any[] =
[
{ text: 'Backlog', dataField: 'new', maxItems: 5 },
{ text: 'In Progress', dataField: 'work', maxItems: 5 },
{ text: 'Done', dataField: 'done', maxItems: 5 }
];
kanbanThreeColumnRenderer: any = (element: any, collapsedElement: any, column: any): void => {
if (this.myKanbanThree && element[0]) {
let columnItems = this.myKanbanThree.getColumnItems(column.dataField).length;
let headerStatus = element[0].getElementsByClassName('jqx-kanban-column-header-status')[0];
headerStatus.innerHTML = ' (' + columnItems + '/' + column.maxItems + ')';
let collapsedHeaderStatus = collapsedElement[0].getElementsByClassName('jqx-kanban-column-header-status')[0];
collapsedHeaderStatus.innerHTML = ' (' + columnItems + '/' + column.maxItems + ')';
}
}
mainSplitterPanels: any[] = [{ size: 250, min: 100 }, { min: 250 }];
rightSplitterPanels: any[] = [{ min: 200, size: 350, collapsible: false }, { min: 200 }];
}

Vue UI Components Documentation

Vue Kanban Component

The Kanban component for Vue can be used to implement the kanban method for a project.

Prerequisites

Refer to Vue Getting Started before you start with this help topic.

Configuration

After you have created your App.vue file, here is how you should structure it:

The Kanban component for Vue requires the following import:

import JqxKanban from "jqwidgets-scripts/jqwidgets-vue/vue_jqxkanban.vue";

Add the jqxKanban component to the components section of the the Vue class:

 components: {
JqxKanban
},

Template

The App.vue has a <template> structural tag where we determine the application structure. There we will also set the tags for the new components - <JqxKanban/>

<template>
<JqxKanban :width="400" :height="400"
:columns="kanbanColumns" :resources="staff"
:source="kanbanSource">
</JqxKanban>
</template>

Properties

The properties of the <JqxKanban/> component are defined in the data member of the Vue class. We should put them in the return object of the data function:

data: function () {
return {
staff: [
{ id: 0, name: 'No name', image: 'images/common.png', common: true },
{ id: 1, name: 'Andrew Fuller', image: 'images/andrew.png' },
{ id: 2, name: 'Janet Leverling', image: 'images/janet.png' },
{ id: 3, name: 'Steven Buchanan', image: 'images/steven.png' }
],
kanbanColumns: [
{ text: 'Backlog', dataField: 'new', access: 'none', maxItems: 5 },
{ text: 'In Progress', dataField: 'work', access: 'none', maxItems: 5 },
{ text: 'Done', dataField: 'done', access: 'none', maxItems: 5, collapseDirection: 'right' }
],
kanbanSource: [
{ id: 3, status: 'done', text: 'Combine Orders', tags: 'orders, combine', color: '#5dc3f0', resourceId: 3 },
{ id: 4, status: 'work', text: 'Change Billing Address', tags: 'billing', color: '#6bbd49', resourceId: 1 },
{ id: 5, status: 'new', text: 'One item added to the cart', tags: 'cart', color: '#5dc3f0', resourceId: 3 },
{ id: 6, status: 'work', text: 'Login 404 issue', tags: 'issue, login', color: '#6bbd49' }
]
}
}

Events

The events in Vue are set as an attribute with @ prefix, for example:

<JqxKanban @columnAttrClicked="onColumnAttrClick()"
:width="400" :height="400"
:columns="kanbanColumns" :resources="staff"
:source="kanbanSource">
</JqxKanban>

All events that are bound to a component are implemented in the methods member of the Vue class.

methods: {
onColumnAttrClick: function () {
// Do something...
}
}

Methods

To use a component's method we should have its reference. In Vue we refer to a component by the special $refs property. Before that we need to add the desired name reference to that component:

<JqxKanban ref="kanban"></JqxKanban>

Here how you can use a component's method:

this.$refs.kanban.getItems();

If we want to add additional methods we should also implement them in the methods member.

In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate member. It depends on the case.

If you have followed the above steps, you App.vue file would look like this:

App.vue:

Kanban Example

<template>
<div>
<JqxKanban @itemMoved="myKanbanOnItemMoved($event)"
@columnCollapsed="myKanbanOnColumnCollapsed($event)"
@columnExpanded="myKanbanOnColumnExpanded($event)"
@itemAttrClicked="myKanbanOnItemAttrClicked($event)"
@columnAttrClicked="myKanbanOnColumnAttrClicked($event)"
:width="width" :source="dataAdapter" :columns="columns"
:resources="resourcesAdapterFunc()">
</JqxKanban>
<div ref="myLog"></div>
</div>
</template>
<script>
import JqxKanban from "jqwidgets-scripts/jqwidgets-vue/vue_jqxkanban.vue";
export default {
components: {
JqxKanban,
},
data: function () {
return {
width: 400,
dataAdapter: new jqx.dataAdapter(this.source),
columns: [
{ text: 'Backlog', dataField: 'new' },
{ text: 'In Progress', dataField: 'work' },
{ text: 'Done', dataField: 'done' }
]
}
},
beforeCreate: function () {
this.log = [];
const fields = [
{ name: 'id', type: 'string' },
{ name: 'status', map: 'state', type: 'string' },
{ name: 'text', map: 'label', type: 'string' },
{ name: 'tags', type: 'string' },
{ name: 'color', map: 'hex', type: 'string' },
{ name: 'resourceId', type: 'number' }
];
this.source = {
localData: [
{ id: '1161', state: 'new', label: 'Make a new Dashboard', tags: 'dashboard', hex: '#36c7d0', resourceId: 3 },
{ id: '1645', state: 'work', label: 'Prepare new release', tags: 'release', hex: '#ff7878', resourceId: 1 },
{ id: '9213', state: 'new', label: 'One item added to the cart', tags: 'cart', hex: '#96c443', resourceId: 3 },
{ id: '6546', state: 'done', label: 'Edit Item Price', tags: 'price, edit', hex: '#ff7878', resourceId: 4 },
{ id: '9034', state: 'new', label: 'Login 404 issue', tags: 'issue, login', hex: '#96c443' }
],
dataType: 'array',
dataFields: fields
};
},
methods: {
resourcesAdapterFunc: function () {
let resourcesSource =
{
localData: [
{ id: 0, name: 'No name', image: 'images/common.png', common: true },
{ id: 1, name: 'Andrew Fuller', image: 'images/andrew.png' },
{ id: 2, name: 'Janet Leverling', image: 'images/janet.png' },
{ id: 3, name: 'Steven Buchanan', image: 'images/steven.png' },
{ id: 4, name: 'Nancy Davolio', image: 'images/nancy.png' },
{ id: 5, name: 'Michael Buchanan', image: 'images/Michael.png' },
{ id: 6, name: 'Margaret Buchanan', image: 'images/margaret.png' },
{ id: 7, name: 'Robert Buchanan', image: 'images/robert.png' },
{ id: 8, name: 'Laura Buchanan', image: 'images/Laura.png' },
{ id: 9, name: 'Laura Buchanan', image: 'images/Anne.png' }
],
dataType: 'array',
dataFields: [
{ name: 'id', type: 'number' },
{ name: 'name', type: 'string' },
{ name: 'image', type: 'string' },
{ name: 'common', type: 'boolean' }
]
};
let resourcesDataAdapter = new jqx.dataAdapter(resourcesSource);
return resourcesDataAdapter;
},
updateLog: function () {
let count = 0;
let str = '';
for (let i = this.log.length - 1; i >= 0; i--) {
str += this.log[i] + '<br/>';
count++;
if (count > 10)
break;
}
this.$refs.myLog.innerHTML = str;
},
myKanbanOnItemMoved: function (event) {
let args = event.args;
let itemId = args.itemId;
let oldParentId = args.oldParentId;
let newParentId = args.newParentId;
let itemData = args.itemData;
let oldColumn = args.oldColumn;
let newColumn = args.newColumn;
this.log.push('itemMoved is raised');
this.updateLog();
},
myKanbanOnColumnCollapsed: function (event) {
let args = event.args;
let column = args.column;
this.log.push('columnCollapsed is raised');
this.updateLog();
},
myKanbanOnColumnExpanded: function (event) {
let args = event.args;
let column = args.column;
this.log.push('columnExpanded is raised');
this.updateLog();
},
myKanbanOnItemAttrClicked: function (event) {
let args = event.args;
let itemId = args.itemId;
let attribute = args.attribute; // template, colorStatus, content, keyword, text, avatar
this.log.push('itemAttrClicked is raised');
this.updateLog();
},
myKanbanOnColumnAttrClicked: function (event) {
let args = event.args;
let column = args.column;
let cancelToggle = args.cancelToggle; // false by default. Set to true to cancel toggling dynamically.
let attribute = args.attribute; // title, button
this.log.push('columnAttrClicked is raised');
this.updateLog();
}
}
}
</script>
<style>
</style>

Run Code

React UI Components Documentation
Typescript React Kanban Component
This tutorial will show you the basics of how to get started with the jQWidgets Kanban React Component.
Prerequisites
Refer to Getting Started with React before you start with this help topic.
Structure
I. Imports:
import * as React from 'react'; import 'jqwidgets-scripts/jqwidgets/styles/jqx.base.css';import 'jqwidgets-scripts/jqwidgets/styles/jqx.material-purple.css';import JqxKanban, { IKanbanProps } from 'jqwidgets-scripts/jqwidgets-react-tsx/jqxkanban';
II. Class:
class App extends React.PureComponent<{}, IKanbanProps> { constructor(props: {}) { super(props); this.state = { width: '100%' // Other Widget Props } } render() { return ( <JqxKanban width={this.state.width} height={"100%"} ..... /> ) }}
III. Render:
ReactDOM.render(<App />, document.getElementById('app'));
Events
The event names in React are constructed of the original event names starting with capital letter plus on upfront:
class App extends React.PureComponent<{}, IKanbanProps> { constructor(props: {}) { super(props); this.state = { width: '100%' // Other Widget Props } } render() { return ( <JqxKanban onNameOfEvent={this.handleEvent} width={this.state.width} height={"100%"} ..... /> ) } private handleEvent(e: Event): void { // Do Something ... }}
Methods & Properties
This is how you call methods & props:
//Get Methodsconst value = this.myKanban.current!.methodName(arg1, arg2); //Set Methodsthis.myKanban.current!.methodName(arg1, arg2); //Get Propertiesconst height = this.state.height; //Set Propertiesthis.setState({ height: 250 });
Every component have a method setOptions which accepts a object as an argument. This object contains component settings.
this.myKanban.current!.setOptions({ width: 350, height: 400 });
Every component also have a method getOptions which returns the value of the requested option.
const width = this.myKanban.current!.getOptions('width');
Kanban API
API Reference of the jQWidgets Kanban React Component: Kanban API
Kanban Demos
Demos Reference of the jQwidgets Kanban React Component: Kanban Demos